{Copyright (C) 2005-2011 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
Publique Générale GNU publiée par la Free Software Foundation (version 2 ou bien toute autre version
ultérieure choisie par vous).

Ce programme est distribué car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spécifique.
 Reportez-vous à la Licence Publique Générale GNU pour plus de détails.

Vous devez avoir reçu une copie de la Licence Publique Générale GNU en même temps que ce programme;
 si ce n'est pas le cas, écrivez à la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, États-Unis.
 }

unit command10;//commandes communes au deux modes

{$MODE Delphi}

interface
Uses 
Sysutils,
{$IFDEF GUI}
Dialogs, controls, Graphics,
{$ELSE}
UnitLog,
{$ENDIF}
classes, listes2, complex3, analyse4,command5,command53d,graph1_6,graph2_7;

const
	{$IFDEF WINDOWS}
	sep='\';
	{$ENDIF}
	{$IFDEF UNIX}
	sep='/';
	{$ENDIF}



procedure GraphExport(mode: integer); //exporte le graphique dans le fichier ExportName

procedure AfficheMessage(const message:string);

procedure recalculer(tous:boolean);

function LireFichier(Const fichier: string):boolean;//lecture d'un fichier source

procedure initialisation;//au chargement du programme
procedure finalisation; //au changement de fichiers

{$IFDEF GUI}
var
         mac2d, mac3d:Tstrings;
         TimerMac: Pexpression;
         MyBitmap, drawBitmap: Tbitmap;
         YaDrawBitmap: boolean;

{$ENDIF}

Implementation

{===================}
procedure GraphExport(mode: integer);
var chemin, aux, oldDir:string;
    mac: Pmacros;
    {$IFDEF GUI}
    pict:tbitmap;
    {$ENDIF}
begin
	    //assignFile(f,ExportName);
            aux:=ExportName;
	    case mode of
              obj : //export de la scene 3D construite avc Build3D  au format obj (facettes+lignes seulement)
                   begin
                        enregistrer_elements(obj,cadre,Exportname);
                   end;
              geom : //export de la scene 3D construite avc Build3D  au format geomview (facettes+lignes seulement)
                   begin
                        enregistrer_elements(geom,cadre,Exportname);
                   end;
              jvx : //export de la scene 3D construite avc Build3D  au format javaview (facettes+lignes+labels )
                   begin
                        enregistrer_elements(jvx,cadre,Exportname);
                   end;
              {$IfDef GUI}
              bmp: begin  pict:=TBitmap.Create;
                          pict.width:=MyBitmap.width;
                          pict.height:=MyBitmap.height;
                          pict.Canvas.Draw(0,0,MyBitmap);
                          pict.SaveToFile(Exportname);
                          pict.free
                    end;
              {$EndIf}
              psf:  //export eps+Psfrag
                 begin
                       UsePsfrag:=true;
                       delete(aux,Length(aux)-2,3);
                       aux:=aux+'eps';
                       assignFile(psfrag,ExportName);
                       //AssignFile(f,aux);
                       enregistrer_elements(eps,cadre,aux);
                       writeln(psfrag,'\includegraphics{'+ExtractFileName(aux)+'}');
                       CloseFile(psfrag);
                       UsePsfrag:=false;
                 end;
              pdf:   //export pdf non compilé
                     begin
                          delete(aux,Length(aux)-2,3);
                          aux:=aux+'eps';
                          //assignFile(f,aux);
                          enregistrer_elements(eps,cadre,aux);
                          mac:=macros('pdfprog');
                          if (mac=nil) or (mac^.contenu=nil) or (mac^.contenu^.corps=nil)
                             then chemin:='epstopdf'
                             else begin
                                chemin:=MakeString(mac^.contenu^.corps);
                                systemExec(chemin+' '+aux,true)
                                end;
                     end;
            compileEps: //export eps compilé
                        begin
                        GetDir(0,oldDir);ChDir(TmpPath);
                        {$IFDEF GUI} Apercu:=true;{$ENDIF}
                        //AssignFile(f,'file.pst');
                        enregistrer_elements(pstricks,cadre,'file.pst');
                        mac:=macros('CompileEps');
                        if (mac=nil) or (mac^.contenu=nil) or (mac^.contenu^.corps=nil)
                             then
                             else begin
                                chemin:=MakeString(mac^.contenu^.corps);
                                systemExec(chemin+' '
				{$IFNDEF GUI}+oldDir+sep{$ENDIF}
				+ChangeFileExt(aux,''),true);
                                end;
                          {$IFDEF GUI} Apercu:=false;{$ENDIF}
                          ChDir(oldDir);
                     end;
            compilePdf: //export pdf compilé
                        begin
                          GetDir(0,oldDir);
                          ChDir(TmpPath);
                          //assignFile(f,'frame1.pgf');
                          {$IFDEF GUI} Apercu:=true;{$ENDIF}
                          enregistrer_elements(pgf,cadre,'frame1.pgf');
                          mac:=macros('CompilePdf');
                          if (mac=nil) or (mac^.contenu=nil) or (mac^.contenu^.corps=nil)
                             then
                             else begin
                              chemin:=MakeString(mac^.contenu^.corps);
                              SystemExec(chemin+' '
                              {$IFNDEF GUI}+oldDir+sep{$ENDIF}
				+ChangeFileExt(aux,''),true);
                                   end;
                          {$IFDEF GUI} Apercu:=false;{$ENDIF}
                          ChDir(oldDir);
                     end;
              else enregistrer_elements(mode,cadre,ExportName);
              end;
end;
{===================}
procedure AfficheMessage(const message:string);
begin
	{$IFDEF GUI}
	Messagedlg(message,mtWarning,[mbOk],0)
	{$ELSE}
	WriteLog(message)
	{$ENDIF}
end;
{===================}
procedure recalculer(tous:boolean);
var aux:PVarGlob;
    mac:Pmacros;
begin
     aux:=PVarGlob(VariablesGlobales^.tete);
     while aux<>nil do
           begin
                aux^.recalculer;
                aux:=PVarGlob(aux^.suivant);
           end;
     mac:=Pmacros(LesMacros^.tete);
     while mac<>nil  do
           begin
                mac^.Recompiler;
                mac:=Pmacros(mac^.suivant);
           end;
     recalculer_elements(tous) (* tous ou peut etre pas tous *);
end;

{============================= Lecture en entrée ==============}
procedure ParseModeInLine(Ltoken:Tlist; Unechaine:string);//parser le mode pour LaTeX
Const AfficheError:boolean=true;
type Tetat=(load,defvar,defmac,defCmd,defgraph);

var p,p1:Pcorps; h:Pexpression; mac:Pmacros;
    graph:Putilisateur;
    dep,arriv,i,j:longint;
    etat:Tetat;
    tok:Ptoken;
    nom:string;
    res:Paffixe;
    aux:Pliste;
    ok:boolean;
    f:textfile;

    function lireNext:boolean;
    begin
         Inc(i);Result:=true;
         if i<Ltoken.Count then tok:=PToken(Ltoken.Items[i]);
         if (i>=Ltoken.Count) then
            begin
                ErrorPos:=tok.index;
                Result:=false;
            end
         else
             if (tok.code=Trubrique)
             then
              if tok.contenu='Include' then etat:=load
                                   else
              if tok.contenu='Var' then etat:=defvar
                                  else
              if tok.contenu='Mac' then etat:=defmac
                                  else
              if tok.contenu='Graph' then etat:=defgraph
                                    else
              if tok.contenu='Cmd' then etat:=defcmd else
             else dec(i);//on reste dans la m^eme rubrique

    end;

    function lireNom:boolean;
    begin
         Inc(i);Result:=true;
         if i<Ltoken.Count then tok:=PToken(Ltoken.Items[i]);
         if (i>=Ltoken.Count) or (tok.code<>Tid) then
            begin
                AnaLyseError:=true;
                ErrorMessage:='un nom est attendu';
                if tok^.contenu<>'' then
                ErrorMessage:=ErrorMessage+' et '+tok^.contenu+' trouvé';
                ErrorPos:=tok.index;
                ErrorLg:=tok.lg;
                Result:=false;
            end
         else nom:=tok.contenu;
    end;

    function lireEgalite:boolean;
    begin
         Inc(i); Result:=true;
         if i<Ltoken.Count then tok:=PToken(Ltoken.Items[i]);
         if (i>=Ltoken.Count) or (tok.code<>Tope)
            or (tok.contenu<>'Egal') then
            begin
                AnaLyseError:=true;
                ErrorMessage:='symbole = attendu';
                if tok^.contenu<>'' then
                ErrorMessage:=ErrorMessage+' et '+tok^.contenu+' trouvé';
                ErrorPos:=tok.index;
                ErrorLg:=tok.lg;
                Result:=false;
            end
    end;

    function ChercherEnd:boolean;
    var stop:boolean;
    begin
         j:=i+1; Result:=true; stop:=(j>=Ltoken.Count);
         while  (not stop) do
                begin
                    tok:=PToken(Ltoken.Items[j]);
                    Inc(j);
                    stop:= (tok.code=Tend) or (tok.code=Trubrique) or (j>=Ltoken.Count)
               end;
         if  (tok.code<>Tend) then
             if (tok.code=Trubrique)then
                begin
                     AnaLyseError:=true;
                     ErrorMessage:='symbole ; attendu';
                     if tok^.contenu<>'' then
                     ErrorMessage:=ErrorMessage+' et '+tok^.contenu+' trouvé';
                     ErrorPos:=tok.index;
                     ErrorLg:=tok.lg;
                     Result:=false;
                end
             else begin
                     AnaLyseError:=true;
                     ErrorMessage:='symbole ; attendu mais non trouvé.';
                     ErrorPos:=tok.index;
                     ErrorLg:=tok.lg;
                     Result:=false;
                  end;

    end;
    

begin
      p:=nil; i:=-1; etat:=defcmd;
      AnalyseError:=AnalyseError or (not lirenext);
      If (not AnalyseError) and (Ltoken.Count>0)
         then                                          //parcourt des tokens
         begin
             DefaultSettings;
             while (not AnalyseError) and (i<Ltoken.Count) do
              begin
                  case etat of
                  load: begin
                             Inc(i);
                             if i<Ltoken.Count then tok:=PToken(Ltoken.Items[i]);
                             if (i>=Ltoken.Count) or (tok.code<>Tmess) then
                                begin
                                     AnaLyseError:=true;
                                     ErrorMessage:='Include: Une chaine de caractères est attendue';
                                     ErrorPos:=tok.index;
                                     ErrorLg:=tok.lg;
                                end
                             else
                             begin
                                  nom:=tok.contenu;
                                  Inc(i);
                                  if i<Ltoken.Count then tok:=PToken(Ltoken.Items[i]);
                                  if (i>=Ltoken.Count) or (tok.code<>Tend) then
                                     begin
                                          AnaLyseError:=true;
                                          ErrorMessage:='Include '+nom+': un ; est attendu';
                                          ErrorPos:=tok.index;
                                          ErrorLg:=tok.lg;
                                     end
                                  else
                                      begin //on crée la commande InpuMac(nom)

                                         p:=new(Pcorps,init(cat_commande,commande('InputMac')));
                                         p^.ajouter_arg(new(Pcorps,init(cat_string,new(Pstring,init(nom)))));
                                         res:=p^.evaluer;
                                         Kill(Pcellule(res));
                                         dispose(p,detruire);
                                         lirenext
                                      end
                             end;
                           end;
                   defCmd: if ChercherEnd then
                           begin //exécution d'une commande
                                 new(h,init);
                                 aux:=LesVarLoc;
                                 LesVarLoc:=h^.VarLoc;
                                 analyser(Ltoken,i+1,j-2,p);
                                 h^.corps:=p;
                                 LesVarLoc:=aux;
                                 if not AnalyseError then
                                    begin
                                         res:=h^.evaluer;
                                         Kill(Pcellule(res))
                                    end;
                                 dispose(h,detruire);
                                 i:=j-1;
                                 lirenext
                           end
                           else ErrorMessage:='Cmd: '+ErrorMessage;
                   defvar: begin
                             nom:='';
                             if lireNom and lireEgalite and ChercherEnd then
                                      //on crée la variable
                                      if VariableValide(nom,false) then
                                      begin
                                           new(h,init);
                                           aux:=LesVarLoc;
                                           LesVarLoc:=h^.VarLoc;
                                           analyser(Ltoken,i+1,j-2,p);
                                           h^.corps:=p;
                                           LesVarLoc:=aux;
                                          if not AnalyseError then
                                           if MacroStatut<>predefmac then
                                           begin
                                            dep:=Ptoken(Ltoken.Items[i+1])^.index;
                                            arriv:=Ptoken(Ltoken.Items[j-1])^.index-1;
                                            VariablesGlobales^.ajouter_fin(new(PVarGlob,init(Nom,
                                             Stringreplace(Copy(Unechaine,dep,arriv-dep+1),slineBreak+#9,'',[rfReplaceAll])
                                             )));
                                           end
                                           else
                                            begin
                                            res:=h^.evaluer;
                                            LesConstantes^.ajouter_fin(new(Pconstante,
                                                                       init(Nom,res,false)));
                                            end;
                                           dispose(h,detruire);
                                           i:=j-1;
                                           lirenext
                                      end
                                      else
                                          begin
                                          {$IFDEF GUI}
                                                  if AfficheError then
                                                  AfficheError:=(Messagedlg(nom+
                                                    ': nom de variable invalide ou déjà définie [Cancel pour stopper les messages]',
                                                     mtWarning,[mbok,mbcancel],0)=mrOk);
                                          {$ENDIF}
                                          i:=j-1;
                                          lirenext
                                               {AnalyseError:=true;
                                               ErrorMessage:='Variable '+nom+': nom invalide';
                                               ErrorLg:=tok.lg;}
                                          end
                                else ErrorMessage:='Variable '+nom+': '+ErrorMessage
                             end;

                   defmac: begin
                             nom:='';
                             if lireNom and lireEgalite and ChercherEnd then
                                      //on crée la macro
                                      if NomMacroValide(nom,MacroStatut=predefmac) then
                                      begin
                                           new(h,init);
                                           aux:=LesVarLoc;
                                           LesVarLoc:=h^.VarLoc;
                                           analyser(Ltoken,i+1,j-2,p);
                                           h^.corps:=p;
                                           LesVarLoc:=aux;
                                         if not AnalyseError then
                                         begin
                                           mac:=new(PMacros,init(nom,h));
                                           if MacroStatut=usermac then
                                            begin
                                              dep:=Ptoken(Ltoken.Items[i+1])^.index;
                                              arriv:=Ptoken(Ltoken.Items[j-1])^.index-1;
                                              mac^.SetCommande( //on retire les tabulations
                                                Stringreplace(Copy(Unechaine,dep,arriv-dep+1),slineBreak+#9,slinebreak,[rfReplaceAll]));
                                            end;
                                           if nom='Exit' then
                                              begin
                                                   ExitMacros^.ajouter_debut(PCellule(mac));
                                                   if  MacroStatut=usermac then ajouter_macros(mac^.dupliquer);
                                              end
                                           else ajouter_macros(mac);
                                         end else dispose(h,detruire);
                                           i:=j-1;
                                           lirenext
                                      end
                                      else
                                          begin
                                          {$IFDEF GUI}
                                          if AfficheError then
                                          AfficheError:=(Messagedlg(nom+
                                                         ': nom de macro invalide ou déjà  définie [Cancel pour stopper les messages]',
                                                          mtWarning,[mbok,mbcancel],0)=mrOk);
                                          {$ENDIF}
                                          i:=j-1;
                                          lirenext
                                               {AnalyseError:=true;
                                               ErrorMessage:='Macro '+nom+': nom invalide';
                                               ErrorLg:=tok.lg;}
                                          end
                               else ErrorMessage:='Macro '+nom+': '+ErrorMessage;
                             end;

                   defgraph: begin
                             if i<Ltoken.Count then tok:=PToken(Ltoken.Items[i+1]);
                             if (i>=Ltoken.Count) or (tok.code<>Tid) then
                               begin ok:=true;nom:='';end//pas de nom
                             else ok:=lireNom and lireEgalite;

                             if ok and ChercherEnd then
                                      //on crée l'élément graphique
                                      begin
                                         //DefaultSettings;
                                         new(h,init);
                                         aux:=LesVarLoc;
                                         LesVarLoc:=h^.VarLoc;
                                         analyser(Ltoken,i+1,j-2,p);
                                         h^.corps:=p;
                                         LesVarLoc:=aux;
                                        if not AnalyseError then
                                         begin
                                         graph:=new(PUtilisateur,init(nom,'',-1));
                                         liste_element.ajouter_fin(graph);
                                         graph.DefCommande:=false;
                                         graph.arbre:=h;
                                         graph.ReCalculer;
                                         {$IFDEF GUI}
                                         dep:=Ptoken(Ltoken.Items[i+1])^.index;
                                         arriv:=Ptoken(Ltoken.Items[j-1])^.index-1;
                                         graph.LigneCommande:= //on retire les tabulations
                                           Stringreplace(Copy(Unechaine,dep,arriv-dep+1),slineBreak+#9,slinebreak,[rfReplaceAll]);
                                         {$ENDIF}
                                         end else dispose(h,detruire);
                                         i:=j-1;
                                         lirenext
                                      end
                               else ErrorMessage:='Graph '+nom+': '+ErrorMessage
                             end;
                  end;
             end
         end
          else if not AnaLyseError
               then ErrorMessage:='Votre commande est une chaine vide!';

      for i:=0 to Ltoken.Count-1 do dispose(Ptoken(Ltoken.Items[i]));
      Ltoken.free
end;
{==================================}
procedure lireModeinLine(Const fichier: string); //expérimental, future format fichier source
var Ltoken:Tlist;
begin
     AnalyseError:=false; ErrorMessage:='';  {initialisation pour la gestion des erreurs}
     Ltoken:=Tlist.create;
     decoupage(LToken, fichier,true);            {tokenisation de la chaine vers Ltoken}
     ParseModeInline(Ltoken,chaine);
end;
{==================}
function LireFichier(Const fichier: string):boolean; //ancienne syntaxe
const forbidden1=[' ',#13,#10,#9];
      AfficheError:boolean=true;

type Tlecture=(Lvaleur, Lnom, Lcommande,Lautre,Lfinie);
var
     mot,commande:string;
     f: textFile;
     nom:Tnom;
     a,b,c,d,e,g:real;
     cat,style,code:integer;
     error:integer;
     h:Pexpression;
     mac:PMacros;
     res:Paffixe;
     stop:boolean;
     diviser,saut:byte;
     lecture:Tlecture;
     forbidden:set of char;

     function test_error:boolean;
     begin
      test_error:=false;
      if error<>0 then
         begin
              LireFichier:=false;
              stop:=true;
              test_error:=true;
              AfficheMessage('Erreur dans une lecture numérique: '+mot)
         end;
     end;


     function Lire_Mot:string;
     var car:char;
         arret:boolean;
     begin
        if (lecture=Lfinie) or eof(f) then begin result:='0'; exit end;
        mot:='';
        result:='';
        arret:=false;
        repeat
                if eof(f) then begin result:=''; exit end;
                read(f,car);
                if (car='%') and (lecture<>Lcommande)
                            then readln(f)
                            else
                if car=car_special
                        then arret:=true
                        else if not (car in forbidden)
                                then result:=result+car;
        until arret;
        if (result='') and (lecture<>Lnom) and (lecture<>Lcommande)
                then
                        begin
                          lecture:=Lfinie; result:='0';
                        end;
        mot:=result;
     end;

     procedure lire_fenetre;
     begin
      val(lire_mot,a,error); if test_error then exit;
      val(lire_mot,b,error); if test_error then exit;
      val(lire_mot,c,error); if test_error then exit;
      val(lire_mot,d,error); if test_error then exit;
      val(lire_mot,e,error); if test_error then exit;
      val(lire_mot,g,error); if test_error then exit;
      graph1_6.fenetre(a,c,b,d,e,g);
      DefaultSettings;
      end;

     procedure lire_marges;
     begin
      val(lire_mot,a,error); if test_error then exit;
      val(lire_mot,b,error); if test_error then exit;
      val(lire_mot,c,error); if test_error then exit;
      val(lire_mot,d,error); if test_error then exit;
      val(lire_mot,style,error); if test_error then exit;
      val(lire_mot,cat,error); if test_error then exit;
      graph1_6.marges(a,b,c,d);
      cadre:=style=1; gestion_couleur:=cat=1;
      PcomptGraph^.affixe^.x:=0;
      val(lire_mot,cat,error); if not test_error then
             PcomptGraph^.affixe^.x:=cat
     end;


     procedure lire_element;
     begin
      lecture:=Lvaleur; forbidden:=forbidden1;
      if (lire_mot='') or eof(f) then exit;
      if mot='TeXgraph' then begin stop:=true;
                                       closefile(f);
                                       LireModeInline(fichier);
                                       system.reset(f);
                             end
                        else
      begin
      val(mot,cat,error);if test_error then exit;
      if cat=cat_ModeInLine then begin stop:=true;
                                       closefile(f);
                                       LireModeInline(fichier);
                                       system.reset(f);
                             end
                        else
      if cat=cat_fenetre then lire_fenetre
                         else
      if cat=cat_marges then lire_marges
                        else
       begin //element macro, variable, commandes, graphiques
      lecture:=Lnom;
      nom:=lire_mot;
      lecture:=Lcommande;
      if cat=cat_const then forbidden:=[#13,#10,#9] else forbidden:=[];
      commande:=lire_mot;
      if commande='' then commande:='1/0';
      lecture:=Lautre; forbidden:=forbidden1;
      case cat of
cat_mac, cat_macGraph2D, cat_macGraph3D:
               if NomMacroValide(nom,MacroStatut=predefmac) then
                 begin
                        new(h,init);
                        if not h^.definir(commande{aux^})
                          then  begin
                                        AfficheMessage('Macro '+nom+': '+ErrorMessage);
                                        dispose(h,detruire)
                                end
                          else  begin mac:=new(PMacros,init(nom,h));
                                      if MacroStatut=0 then mac^.SetCommande(commande);
                                      ajouter_macros(mac);
                                      if (MacroStatut=2) and (cat in [cat_macGraph2D, cat_macGraph3D])
                                        then begin
                                             lecture:=Lcommande; forbidden:=[];
                                             //system.delete(nom,pos('''',nom),1);
                                             {$IFDEF GUI}
                                             case cat of
                                             cat_macGraph2D: mac2d.add(nom+' ['+lire_mot+']');
                                             cat_macGraph3D: mac3d.add(nom+' ['+lire_mot+']');
                                             end;
                                             {$ENDIF}
                                             lecture:=Lautre; forbidden:=forbidden1;
                                             end;
                                end;
                 end
                 else
{$IFDEF GUI}
                 if AfficheError then
                    AfficheError:=(Messagedlg(nom+': nom de macro invalide ou déjà  définie',mtWarning,[mbok,mbcancel],0)=mrOk)
{$ENDIF};

      cat_command: begin new(h,init);
                        //FoncSpeciales:=true;
                         if not h^.definir(commande)
                             then AfficheMessage(commande+': '+ErrorMessage)
                             else h^.evaluer;
                         //FoncSpeciales:=false;
                         dispose(h,detruire);
                    end;

      cat_const: if VariableValide(nom,false) then
                   begin
                      new(h,init);
                      if not h^.definir(commande)
                         then AfficheMessage('Variable '+nom+': '+ErrorMessage)
                         else if MacroStatut=2
                                then LesConstantes^.ajouter_fin(new(Pconstante,init(Nom,h^.evaluer,false)))
                                else VariablesGlobales^.ajouter_fin(new(PVarGlob,init(Nom,commande)));
                      dispose(h,detruire);
                   end else
{$IFDEF GUI}
                   if AfficheError then AfficheError:=MessageDlg(nom+': Nom de variable invalide ou déjà définie',mtWarning,[mbok,mbCancel],0)=mrOk
{$ENDIF};

      cat_axes: ajouter_element(new(Paxes,init(nom,commande)));

      cat_grille: ajouter_element(new(Pgrille,init(nom,commande)));

      else
      begin
      if NomValide(nom,false) then
      case cat of

      cat_dot: ajouter_element(new(Pdot,init(nom,commande)));
      cat_utilisateur: begin
                        lecture:=Lvaleur; val(lire_mot,code,error);
                        if test_error or (code=0) then code:=-1;
                        ajouter_element(new(PUtilisateur,init(nom,commande,code)));
                       end;
      cat_cercle: begin //pour compatibilité
                       ajouter_element(new(PUtilisateur,init(nom,'Cercle('+commande+')',-1)));
                  end;
      cat_label: begin forbidden:=[#10,#13,#9]; ajouter_element(new(Plabel,init(nom,commande,lire_mot))) end;
      cat_ellipse: ajouter_element(new(Pellipse,init(nom,commande)));
      cat_droite: ajouter_element(new(Pdroite,init(nom,commande)));
      cat_parametree, cat_cartesienne, cat_polaire:
                      begin
                      diviser:=0;saut:=0; lecture:=Lvaleur;
                      val(lire_mot,style,error);if not test_error then diviser:=style;
                      val(lire_mot,style,error);if not test_error then saut:=style;
                      case cat of
                      cat_parametree:
                      ajouter_element(new(Pparametree,init(nom,commande,diviser,saut)));
                      cat_cartesienne:
                      ajouter_element(new(Pcartesienne,init(nom,commande,diviser,saut)));
                      cat_polaire:
                      ajouter_element(new(Ppolaire,init(nom,commande,diviser,saut)));
                      end;
                      end;
      cat_bezier: ajouter_element(new(Pbezier,init(nom,commande)));
      cat_spline: ajouter_element(new(Pspline,init(nom,commande)));
      cat_ellipticarc: begin
                    lecture:=Lvaleur;
                    val(lire_mot,cat,error);if test_error then cat:=1;
                    ajouter_element(new(Pellipticarc,init(nom,commande,cat)));
               end;
      cat_polygone: begin
                    lecture:=Lvaleur;
                    val(lire_mot,cat,error);if test_error then exit;
                    val(lire_mot,a,error);if test_error then a:=0;
                    ajouter_element(new(Pligne,init(nom,commande,cat,a)));
                    end;
      cat_Path: begin
                    lecture:=Lvaleur;
                    val(lire_mot,cat,error);if test_error then exit;
                    val(lire_mot,a,error);
                    ajouter_element(new(PPath,init(nom,commande,cat)));
                    end;

      cat_EquaDif:  begin
                    lecture:=Lvaleur;
                    val(lire_mot,cat,error);if test_error then exit;
                    ajouter_element(new(PEquaDif,init(nom,commande,cat)));
                    end;
      cat_Implicit: ajouter_element(new(PImplicit,init(nom,commande)));
      else
      {$IFDEF GUI}
      if AfficheError then AfficheError:= Messagedlg('Catégorie: '+IntToStr(cat)+': invalide',mtWarning,[mbok,mbCancel],0)=mrOk
      {$ENDIF};
      end
      else
{$IFDEF GUI}
      if AfficheError then AfficheError:= Messagedlg('Elément graphique: '+nom+': nom invalide ou déjà  utilisé',mtWarning,[mbok,mbCancel],0)=mrOk
{$ENDIF};
      end;
      end;
      end;
      end;
         while not ((lecture=Lfinie) or eof(f)) do lire_mot;
     end;


 begin
      LireFichier:=true;
      assignFile(f,fichier);
      {$I-}
      system.reset(f);
      {$I+}
      If IOresult<>0 then begin LireFichier:=false;exit; end;
      {$IFNDEF GUI}
      WriteLog('Lecture '+fichier+'...');
      {$ENDIF}
      stop:=false;
      while not stop do
        begin
                lire_element;
                if AnalyseError then
                   begin
                        stop:=true;
                        {$IFNDEF GUI}
                        AfficheMessage('ligne '+Streel(ErrorLg)+': '+ErrorMessage);
                        {$ELSE}
                        AfficheMessage('['+fichier+']'+CRLF+'ligne '+Streel(ErrorLg)+': '+ErrorMessage);
                        {$ENDIF}
                        LireFichier:=false;
                        closeFile(f); exit
                   end;
                stop:=stop or eof(f)
        end;
      closeFile(f);

      mac:=macros('Init');
      if (mac<>nil) and (mac^.statut=MacroStatut) then
        begin
                new(h,init);
                if h^.definir('Init()') then
                        begin
                                res:=h^.evaluer;
                                listes2.Kill(pcellule(res));
                        end;
                dispose(h,detruire);
                if mac^.statut>0 then LesMacros^.supprimer(Pcellule(mac));
        end;
{$IfNDEF GUI}
      writeLog('Lecture '+fichier+' terminée.')
{$ENDIF}
 end;
{=================}
procedure finalisation;
var mac:PCellule;
begin
     mac:=ExitMacros^.tete;  //macros de sortie
     while (mac<>nil) do
        begin
                Pmacros(mac)^.executer(nil);
                mac:=mac^.suivant
        end;
     ExitMacros^.detruire;
     //ExitMacros^.init;
     vider_liste;                    // éléments graphiques
     detruireMacNonPredef;           // macros utilisateurs
     VariablesGlobales^.detruire;    // variales globales
     ListeFicMac.Clear;              // macros chargées
     filechanged:=false;
end;
{=================}
procedure initialisation;
var h:Pexpression;
    m:Pmacros;
begin
     InitialPath:=GetEnvironmentVariable('TeXgraphDir');
     if InitialPath='' then InitialPath:=GetCurrentDir;
     {$IFDEF MSWINDOWS}
     InitialPath:=InitialPath+'\';
     UserMacPath:=GetEnvironmentVariable('TeXgraphMac');
     if UserMacPath<>'' then  UserMacPath:=UserMacPath+'\';
     TmpPath:='c:\tmp\';
     if not DirectoryExists(TmpPath) then CreateDir(TmpPath);
     MacPath:=InitialPath+'macros\';
     if not FileExists(TmpPath+'CompileEps.tex') then
       SystemExec('cmd /C copy '+InitialPath+'CompileEps.tex ' +TmpPath+'CompileEps.tex',true);
     if not FileExists(TmpPath+'tex2FlatPs.tex') then
       SystemExec('cmd /C copy '+InitialPath+'tex2FlatPs.tex ' +TmpPath+'tex2FlatPs.tex',true);
	{$IFDEF GUI}
	Docpath:=InitialPath+'doc\';
       UserPath:=initialPath;
       if not FileExists(TmpPath+'formule.tex') then
       SystemExec('cmd /C copy '+InitialPath+'formule.tex ' +TmpPath+'formule.tex',true);
     if not FileExists(TmpPath+'apercu.tex') then
       SystemExec('cmd /C copy '+InitialPath+'apercu.tex ' +TmpPath+'apercu.tex',true);
     if not FileExists(TmpPath+'TeXgraph.cfg') then
       SystemExec('cmd /C copy '+InitialPath+'TeXgraph.cfg ' +TmpPath+'TeXgraph.cfg',true);
	{$ENDIF}
     {$ENDIF}
     {$IFDEF UNIX}
     InitialPath:=InitialPath+'/';
     UserMacPath:=GetEnvironmentVariable('HOME')+'/TeXgraphMac/';
     TmpPath:=GetEnvironmentVariable('HOME')+'/.TeXgraph/';
     if not DirectoryExists(TmpPath) then CreateDir(TmpPath);
     if not DirectoryExists(UserMacPath) then CreateDir(UserMacPath);
     MacPath:=InitialPath+'macros/';
     if not FileExists(TmpPath+'CompileEps.tex') then
       SystemExec('cp -f '+InitialPath+'CompileEps.tex ' +TmpPath+'CompileEps.tex',true);
     if not FileExists(TmpPath+'tex2FlatPs.tex') then
       SystemExec('cp -f '+InitialPath+'tex2FlatPs.tex ' +TmpPath+'tex2FlatPs.tex',true);
	{$IFDEF GUI}
	DocPath:=GetEnvironmentVariable('TeXgraphDocDir');
        if DocPath='' then DocPath:=InitialPath+'doc/'
                   else DocPath:=DocPath+'/';

        if not FileExists(TmpPath+'formule.tex') then
           SystemExec('cp -f '+InitialPath+'formule.tex ' +TmpPath+'formule.tex',true);
        if not FileExists(TmpPath+'apercu.tex') then
           SystemExec('cp -f '+InitialPath+'apercu.tex ' +TmpPath+'apercu.tex',true);
        if not FileExists(TmpPath+'TeXgraph.cfg') then
           SystemExec('cp -f '+InitialPath+'TeXgraph.cfg ' +TmpPath+'TeXgraph.cfg',true);
	{$ENDIF}
     {$ENDIF}

     New(h,init);
     h^.definir('"'+InitialPath+'"');
     m:=new(PMacros,init('InitialPath',h));
     m^.statut:=2;
     ajouter_macros(m);

     New(h,init);
     h^.definir('"'+TmpPath+'"');
     m:=new(PMacros,init('TmpPath',h));
     m^.statut:=2;
     ajouter_macros(m);

     New(h,init);
     h^.definir('"'+UserMacPath+'"');
     m:=new(PMacros,init('UserMacPath',h));
     m^.statut:=2;
     ajouter_macros(m);

     {$IFDEF GUI}
     New(h,init);
     h^.definir('"'+DocPath+'"');
     m:=new(PMacros,init('DocPath',h));
     m^.statut:=2;
     ajouter_macros(m);
     
     //Timer
     new(TimerMac,init);
     TimerMac^.definir('"1/0"');
     {$ENDIF}

     macroStatut:=2; //macro permanente
     //lecture color.mac
     Constpredefinie:=true;
     If not FileExists(MacPath+'color.mac') then  AfficheMessage('color.mac n''est pas dans le répertoire '+MacPath)
     else begin LireFichier(MacPath+'color.mac');
          end;
     Constpredefinie:=false;

     //lecture TeXgraph.mac
     If not FileExists(MacPath+'TeXgraph.mac') then AfficheMessage('TeXgraph.mac n''est pas dans '+MacPath)
     else LireFichier(MacPath+'TeXgraph.mac');

     macroStatut:=0; //macros utilisateur
end;
{=======================}
Initialization

        {$IFDEF GUI}
        mac2d:=TStringList.Create; mac3d:=TStringList.Create;
        {$ENDIF}
Finalization
        {$IFDEF GUI}
        mac2d.free; mac3d.free;
        {$ENDIF}

end.
